package com.glxp.api.admin.controller.inout.utils;

import com.glxp.api.admin.constant.ConstantStatus;
import com.glxp.api.admin.entity.basic.BasicThirdSysEntity;
import com.glxp.api.admin.entity.basic.BussinessTypeEntity;
import com.glxp.api.admin.entity.basic.UdiInfoEntity;
import com.glxp.api.admin.entity.basic.UdiRelevanceEntity;
import com.glxp.api.admin.entity.info.SystemParamConfigEntity;
import com.glxp.api.admin.entity.inout.OrderEntity;
import com.glxp.api.admin.entity.inout.WarehouseEntity;
import com.glxp.api.admin.entity.inout.ErpOrderEntity;
import com.glxp.api.admin.entity.inout.FilterErpOrderRequest;
import com.glxp.api.admin.req.basic.FilterUdiInfoRequest;
import com.glxp.api.admin.req.inout.OrderFilterRequest;
import com.glxp.api.admin.res.basic.UdiRelevanceResponse;
import com.glxp.api.admin.service.basic.BasicThirdSysService;
import com.glxp.api.admin.service.basic.CustomService;
import com.glxp.api.admin.service.basic.UdiInfoService;
import com.glxp.api.admin.service.basic.UdiRelevanceService;
import com.glxp.api.admin.service.info.SystemParamConfigService;
import com.glxp.api.admin.service.inout.CodesService;
import com.glxp.api.admin.service.inout.OrderDetailService;
import com.glxp.api.admin.service.inout.OrderService;
import com.glxp.api.admin.thread.InvProductsTrService;
import com.glxp.api.admin.thread.IoTransInoutService;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Service
public class ContrastErpUtil {

    int erpTotalCount;
    String udiUrl = "";
    @Resource
    InvProductsTrService invProductsTrService;
    @Resource
    CustomService customService;
    @Resource
    InoutUtils inoutUtils;
    @Resource
    UdiRelevanceService udiRelevanceService;
    @Resource
    private OrderDetailService myErpOrderService;
    @Resource
    private CodesService codesService;
    @Resource
    private OrderService orderService;
    @Resource
    IoTransInoutService ioTransInoutService;

    public ContrastErpUtil() {

    }

    public ContrastErpUtil(String udiUrl) {
        this.udiUrl = udiUrl;
    }

    public void contrastErp(UdiInfoService udiInfoService, UdiRelevanceService udiRelevanceService,
                            OrderDetailService myErpOrderService,
                            OrderService orderService,
                            List<WarehouseEntity> warehouseEntityList,
                            SystemParamConfigService setupService, List<ErpOrderEntity> vailErpOrders) {

        //获取订单
        String orderIdFk = warehouseEntityList.get(0).getOrderId();
        OrderFilterRequest orderFilterRequest = new OrderFilterRequest();
        orderFilterRequest.setId(orderIdFk);
        OrderEntity orderEntity = orderService.findOne(orderFilterRequest);

        //获取生成的本地单据详情，未校验
        FilterErpOrderRequest filterErpOrderRequest = new FilterErpOrderRequest();
        filterErpOrderRequest.setOrderId(orderIdFk);
        List<ErpOrderEntity> orderDetails = myErpOrderService.filterAllMyErpOrder(filterErpOrderRequest);

        //校验本地单据详情是否有包含一个di多个绑定
        String errMsg = null;
        errMsg = vailMutiDi(orderDetails);
        if (errMsg != null) {
            orderEntity.setStatus(ConstantStatus.ORDER_STATUS_SUCCESS);
            orderEntity.setContrastStatus(ConstantStatus.ORDER_CHECK_FAIL);
            orderEntity.setRemark(errMsg);
            orderService.updateOrder(orderEntity);
            return;
        }

        //为每个条码赋值：基础信息表主键
//        for (WarehouseEntity warehouseEntity : warehouseEntityList) {
//            for (ErpOrderEntity erpOrderEntity : orderDetails) {
//                if ((erpOrderEntity.getNameCode() != null && erpOrderEntity.getNameCode().equals(warehouseEntity.getNameCode()))
//                        && (erpOrderEntity.getBatchNo() != null && erpOrderEntity.getBatchNo().equals(warehouseEntity.getBatchNo()))
//                        && (erpOrderEntity.getWarehouseCode() != null && erpOrderEntity.getWarehouseCode().equals(warehouseEntity.getWarehouseCode()))) {
//                    if (erpOrderEntity.getBindRlFk() != null) {
//                        warehouseEntity.setRelId(erpOrderEntity.getBindRlFk());
//                    } else {
//                        warehouseEntity.setRelId(erpOrderEntity.getRelIdFk());
//                    }
//                }
//
//            }
//        }
        //初始化，并计算扫码总数
        if (vailErpOrders != null && vailErpOrders.size() > 0) {
            for (ErpOrderEntity erpOrderEntity : vailErpOrders) {
                if (erpOrderEntity.getErpCount() == null) {
                    erpOrderEntity.setErpCount(0);
                }
                erpTotalCount = erpTotalCount + erpOrderEntity.getErpCount();
                erpOrderEntity.setCount(0);
            }
        }

        //校验单据是否已被校验
        ErpOrderEntity vailExitMsg = vailErpExit(myErpOrderService, vailErpOrders, orderIdFk);
        SystemParamConfigEntity systemParamConfigEntity = setupService.selectByParamKey("erp_forbidSameErp");
        if (vailExitMsg != null && systemParamConfigEntity != null && systemParamConfigEntity.getParamValue().equals("1")) {
            errMsg = "所选ERP单" + vailExitMsg.getErpOrderId() + "已被其他出入库单" + vailExitMsg.getOrderIdFk() + "绑定！";
            returnData(errMsg, orderEntity);
            return;
        }


        List<WarehouseEntity> errorData = new ArrayList<>();
        for (WarehouseEntity warehouseEntity : warehouseEntityList) {

            //根据条码获取产品详情，数量等
            UdiInfoEntity udiInfoEntity = inoutUtils.getUdiInfoByRlId(udiInfoService, udiRelevanceService, warehouseEntity.getCode());
            udiInfoEntity.setCount(customService.getActCount(warehouseEntity));

            if (warehouseEntity.getRelId() == null) {
                errMsg = warehouseEntity.getCode() + "产品信息未维护";
                returnData(errMsg, orderEntity);
                return;
            }

            UdiRelevanceResponse udiRelevanceEntity = udiRelevanceService.selectGroupById(warehouseEntity.getRelId());
            if (udiRelevanceEntity != null) {
                udiInfoEntity.setThirdId(udiRelevanceEntity.getThirdId());
                udiInfoEntity.setThirdName(udiRelevanceEntity.getThirdName());
                udiInfoEntity.setWarehouseCode(warehouseEntity.getWarehouseCode());
                udiInfoEntity.setRelId(udiRelevanceEntity.getId() + "");
                errMsg = vaildErpOrder(vailErpOrders, warehouseEntityList, udiInfoEntity);
                if (errMsg != null && (errMsg.equals("产品信息不匹配") || errMsg.equals("非此单产品批次号"))) {
                    errorData.add(warehouseEntity);
                }
            } else {
                errMsg = "产品信息未维护";
                errorData.add(warehouseEntity);
            }
            if (errMsg != null) {
                returnData(errMsg, orderEntity);
            }

        }
        myErpOrderService.deleteByOrderId(orderIdFk);
        myErpOrderService.insertErpOrders(vailErpOrders);
        if (vailErpOrders != null && vailErpOrders.size() > 0)
            for (ErpOrderEntity erpOrderEntity : vailErpOrders) {
                if (erpOrderEntity.getErpCount() != erpOrderEntity.getCount()) {
                    errMsg = "所选ERP单" + erpOrderEntity.getErpOrderId() + "下" + erpOrderEntity.getGoodsname() + "数量不匹配";
                }
            }

        if (errMsg != null) {
            orderEntity.setContrastStatus(ConstantStatus.ORDER_CHECK_FAIL);
            orderEntity.setRemark(errMsg);
            orderEntity.setStatus(ConstantStatus.ORDER_STATUS_SUCCESS);
            orderService.updateOrder(orderEntity);
        } else {
            orderEntity.setContrastStatus(ConstantStatus.ORDER_CHECK_SUCCESS);
            orderEntity.setStatus(ConstantStatus.ORDER_STATUS_SUCCESS);
            orderService.updateOrder(orderEntity);
            ioTransInoutService.printOrder(orderEntity.getId());
            invProductsTrService.genInvProducts(orderEntity.getId());
        }

        if (errorData.size() > 0) {
            inoutUtils.generateConstrastDetail(udiInfoService, udiRelevanceService, myErpOrderService, errorData);
        }
    }

    public void returnData(String errMsg, OrderEntity orderEntity) {
        if (errMsg != null) {
            orderEntity.setStatus(ConstantStatus.ORDER_STATUS_SUCCESS);
            orderEntity.setContrastStatus(ConstantStatus.ORDER_CHECK_FAIL);
            orderEntity.setRemark(errMsg);
            orderService.updateOrder(orderEntity);
        }
    }


    public String vailMutiDi(List<ErpOrderEntity> mErpOrderEntities) {
        String errMsg = null;
        for (ErpOrderEntity erpOrderEntity : mErpOrderEntities) {

//            FilterUdiInfoRequest filterUdiInfoRequest = new FilterUdiInfoRequest();
//            filterUdiInfoRequest.setNameCode(erpOrderEntity.getNameCode());
//            List<UdiRelevanceResponse> udiRelevanceEntities = udiRelevanceService.filterUdiRelevance(filterUdiInfoRequest);
            WarehouseEntity warehouseEntity = codesService.findOneByNameCode(erpOrderEntity.getOrderIdFk(), erpOrderEntity.getNameCode());

            if (warehouseEntity != null && warehouseEntity.getStatus() == ConstantStatus.ORDER_DETAIL_DI_MUTI) {
//                erpOrderEntity.setBindStatus(ConstantStatus.ORDER_DETAIL_DI_MUTI);
//                myErpOrderService.updateErpOrder(erpOrderEntity);
                if (warehouseEntity.getRelId() == null) {
                    errMsg = "该产品DI绑定多个产品ID，请在扫码单据详情绑定对应产品ID";
                }

            }

//            if (udiRelevanceEntities != null && udiRelevanceEntities.size() > 1 && warehouseEntity.getRelId() == null) {
//                erpOrderEntity.setBindStatus(ConstantStatus.ORDER_DETAIL_DI_MUTI);
//                myErpOrderService.updateErpOrder(erpOrderEntity);
//                errMsg = "该产品DI绑定多个产品ID，请在扫码单据详情绑定对应产品ID";
//            }
        }
        return errMsg;
    }


    public int getSelectedCount(List<WarehouseEntity> warehouseEntityList) {
        int total = 0;
        for (WarehouseEntity warehouseEntity : warehouseEntityList) {
            total = total + warehouseEntity.getCount();
        }
        return total;
    }

    //验证产品ID,批次号，仓位号
    public String vaildErpOrder(List<ErpOrderEntity> mErpOrderEntities, List<WarehouseEntity> warehouseEntityList, UdiInfoEntity udiInfoEntity) {
        String errMsg = "产品信息不匹配";
        if (mErpOrderEntities.size() > 0) {
            for (ErpOrderEntity erpOrderEntity : mErpOrderEntities) {
                errMsg = isPass(erpOrderEntity, udiInfoEntity);
                if (errMsg == null) {
                    int erpCount = erpOrderEntity.getCount() + udiInfoEntity.getCount();
                    if (erpOrderEntity.getErpCount() != erpCount) {
                        erpOrderEntity.setCount(erpCount);
                        if (erpOrderEntity.getErpCount() != erpCount)
                            return "该" + udiInfoEntity.getBatchNo() + "批次号下" + udiInfoEntity.getCpmctymc() + "订单数目不匹配";
                    }
                    erpOrderEntity.setCount(erpCount);
                    return null;
                }
            }
        }
        if (errMsg == null && getSelectedCount(warehouseEntityList) + udiInfoEntity.getCount() != erpTotalCount) {
            return "订单数目匹配失败";
        }
        return errMsg;
    }

    public String isPass(ErpOrderEntity erpOrderEntity, UdiInfoEntity udiInfoEntity) {
        String errMsg = null;
        if (erpOrderEntity.getBatchNo().equals(udiInfoEntity.getBatchNo())) {
            if (erpOrderEntity.getRelIdFk().equals(udiInfoEntity.getRelId())) {
                if (erpOrderEntity.getWarehouseCode() != null && udiInfoEntity.getWarehouseCode() != null) {
                    if (erpOrderEntity.getWarehouseCode().equals(udiInfoEntity.getWarehouseCode())) {
                        return null;
                    } else
                        errMsg = "仓位号不匹配";
                } else
                    return null;
            } else
                errMsg = "产品信息不匹配";
        } else {
            errMsg = "非此单产品批次号";
        }
        return errMsg;
    }

    //把第三方单据加工转换，新增属性
    public List<ErpOrderEntity> transErp(List<ErpOrderEntity> erpOrderEntities, UdiRelevanceService udiRelevanceService, String orderFk, BussinessTypeEntity bussinessTypeEntity) {
        List<ErpOrderEntity> returnOrders = new ArrayList<>();
        Map<String, ErpOrderEntity> filterMap = new HashMap<>();
        if (erpOrderEntities != null && erpOrderEntities.size() > 0) {
            for (ErpOrderEntity erpOrderEntity : erpOrderEntities) {
                UdiRelevanceResponse udiRelevanceResponse = null;
                if (erpOrderEntity.getRelIdFk() != null) {
                    udiRelevanceResponse = udiRelevanceService.selectGroupById(erpOrderEntity.getRelIdFk());
                } else {
                    UdiRelevanceEntity udiRelevanceEntity = udiRelevanceService.selectByThirdId(erpOrderEntity.getGoodsid(), bussinessTypeEntity.getThirdSys());
                    if (udiRelevanceEntity != null) {
                        udiRelevanceResponse = udiRelevanceService.selectGroupById(udiRelevanceEntity.getId());
                        erpOrderEntity.setRelIdFk(udiRelevanceEntity.getId());
                    }

                }
                if (udiRelevanceResponse != null) {
                    erpOrderEntity.setNameCode(udiRelevanceResponse.getNameCode());
                    erpOrderEntity.setCoName(udiRelevanceResponse.getCpmctymc());
                    erpOrderEntity.setAuthCode(udiRelevanceResponse.getZczbhhzbapzbh());
                    erpOrderEntity.setPackSpec(udiRelevanceResponse.getGgxh());
                    erpOrderEntity.setPackRatio(udiRelevanceResponse.getPackRatio());
                    erpOrderEntity.setProductCompany(udiRelevanceResponse.getYlqxzcrbarmc());
                    erpOrderEntity.setOrderIdFk(orderFk);
                } else {
                    erpOrderEntity.setCoName(erpOrderEntity.getGoodsname());
                    erpOrderEntity.setPackSpec(erpOrderEntity.getGoodsunit());
                }
                erpOrderEntity.setOrderIdFk(orderFk);
                String key = erpOrderEntity.getBatchNo() + erpOrderEntity.getRelIdFk() + erpOrderEntity.getWarehouseCode();
                ErpOrderEntity filterTemp = filterMap.get(key);
                if (filterTemp != null) {
                    filterTemp.setErpCount(filterTemp.getErpCount() + erpOrderEntity.getErpCount());
                    filterTemp.setErpOrderId(filterTemp.getErpOrderId() + "," + erpOrderEntity.getErpOrderId());
                } else {
                    filterTemp = erpOrderEntity;
                }
                filterMap.put(key, filterTemp);
            }
            for (Map.Entry<String, ErpOrderEntity> entry : filterMap.entrySet()) {
                returnOrders.add(entry.getValue());
            }
        }


        return returnOrders;
    }


    public List<String> getDocids(List<ErpOrderEntity> erpOrderEntities) {
        Map<String, String> filter = new HashMap<>();
        List<String> docids = new ArrayList<>();
        for (ErpOrderEntity erpOrderEntity : erpOrderEntities) {

            if (erpOrderEntity.getErpOrderId().contains(",")) {
                String[] dociArray = erpOrderEntity.getErpOrderId().split(",");
                if (dociArray != null && dociArray.length > 0) {
                    for (int i = 0; i < dociArray.length; i++) {
                        filter.put(dociArray[i], dociArray[i]);
                    }
                }
            } else {
                filter.put(erpOrderEntity.getErpOrderId(), erpOrderEntity.getErpOrderId());
            }
        }
        for (String docid : filter.keySet()) {
            docids.add(docid);
        }
        return docids;
    }

    //校验Erp单是否存在
    public ErpOrderEntity vailErpExit(OrderDetailService myErpOrderService, List<ErpOrderEntity> erpOrderEntities, String orderId) {
        if (erpOrderEntities != null && erpOrderEntities.size() > 0) {
            FilterErpOrderRequest filterErpOrderRequest = new FilterErpOrderRequest();
            filterErpOrderRequest.setOrderId(orderId);
            List<ErpOrderEntity> docids = myErpOrderService.filterAllDocidE(filterErpOrderRequest);
            if (docids != null && docids.size() > 0) {
                List<String> bDocids = getDocids(erpOrderEntities);
                for (ErpOrderEntity docid : docids) {
                    for (String temp : bDocids) {
                        if (docid.getErpOrderId() != null && docid.getErpOrderId().contains(temp)) {
                            return docid;
                        }
                    }
                }
            }
            return null;
        }
        return null;
    }
}
