package com.glxp.api.admin.service.inventory.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.api.admin.dao.inventory.InvWarehouseDao;
import com.glxp.api.admin.entity.inventory.InvWarehouseEntity;
import com.glxp.api.admin.req.inventory.FilterInvWarehouseRequest;
import com.glxp.api.admin.service.inventory.InvWarehouseService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class InvWarehouseServiceImpl implements InvWarehouseService {


    @Resource
    InvWarehouseDao invWarehouseDao;

    @Override
    public InvWarehouseEntity findDefault(Boolean advaceType, Boolean isDefault) {

        FilterInvWarehouseRequest filterInvWarehouseRequest = new FilterInvWarehouseRequest();
        filterInvWarehouseRequest.setIsDefault(isDefault);
        filterInvWarehouseRequest.setAdvanceType(advaceType);
        List<InvWarehouseEntity> invWarehouseEntities = invWarehouseDao.filterInvWarehouse(filterInvWarehouseRequest);
        if (invWarehouseEntities != null && invWarehouseEntities.size() > 0)
            return invWarehouseEntities.get(0);
        return null;
    }

    @Override
    public List<InvWarehouseEntity> filterInvWarehouse(FilterInvWarehouseRequest filterInvWarehouseRequest) {
        if (filterInvWarehouseRequest == null) {
            return Collections.emptyList();
        }
        if (filterInvWarehouseRequest.getPage() != null) {
            int offset = (filterInvWarehouseRequest.getPage() - 1) * filterInvWarehouseRequest.getLimit();
            PageHelper.offsetPage(offset, filterInvWarehouseRequest.getLimit());
        }
        List<InvWarehouseEntity> data = invWarehouseDao.filterInvWarehouse(filterInvWarehouseRequest);
        return data;
    }

    @Override
    public List<InvWarehouseEntity> filterGroupInvWarehouse(FilterInvWarehouseRequest filterInvWarehouseRequest) {
        if (filterInvWarehouseRequest == null) {
            return Collections.emptyList();
        }
        if (filterInvWarehouseRequest.getPage() != null) {
            int offset = (filterInvWarehouseRequest.getPage() - 1) * filterInvWarehouseRequest.getLimit();
            PageHelper.offsetPage(offset, filterInvWarehouseRequest.getLimit());
        }
        List<InvWarehouseEntity> data = invWarehouseDao.filterGroupInvWarehouse(filterInvWarehouseRequest);
        return data;
    }

    @Override
    public boolean insertInvWarehouse(InvWarehouseEntity invWarehouseEntity) {
        return invWarehouseDao.insertInvWarehouse(invWarehouseEntity);
    }

    @Override
    public boolean updateInvWarehouse(InvWarehouseEntity invWarehouseEntity) {
        return invWarehouseDao.updateInvWarehouse(invWarehouseEntity);
    }

    @Override
    public InvWarehouseEntity selectById(String id) {
        return invWarehouseDao.selectById(id);
    }

    @Override
    public InvWarehouseEntity selectByCode(String code) {
        FilterInvWarehouseRequest filterInvWarehouseRequest = new FilterInvWarehouseRequest();
        filterInvWarehouseRequest.setCode(code);
        List<InvWarehouseEntity> invWarehouseEntities = invWarehouseDao.filterInvWarehouse(filterInvWarehouseRequest);
        if (invWarehouseEntities != null && invWarehouseEntities.size() > 0)
            return invWarehouseEntities.get(0);
        return null;
    }

    @Override
    public boolean deleteById(String id) {
        return invWarehouseDao.deleteById(id);
    }
}
